diff --git a/web/webpack.config.js b/web/webpack.config.js
index 5c992008..bc64081e 100644
--- a/web/webpack.config.js
+++ b/web/webpack.config.js
@@ -24,8 +24,12 @@ const extractStyle = new MiniCssExtractPlugin({
   filename: '[name].css',
   allChunks: true,
 });
+const WebpackRequireFromPlugin = require('webpack-require-from');
+const BundleAnalyzerPlugin = require('webpack-bundle-analyzer').BundleAnalyzerPlugin;
+
 const envType = PRODUCTION ? 'production': 'development';
 const devToolVal = PRODUCTION ? false : 'eval';
+const analyzerMode = process.env.ANALYZE=='true' ? 'static' : 'disabled';
 
 // Expose libraries in app context so they need not to
 // require('libname') when used in a module
@@ -34,7 +38,6 @@ const providePlugin = new webpack.ProvidePlugin({
   jQuery: 'jquery',
   'window.jQuery': 'jquery',
   _: 'underscore',
-  S: 'underscore.string',
   Backbone: 'backbone',
   Backgrid: 'backgrid',
   pgAdmin: 'pgadmin',
@@ -46,7 +49,11 @@ const providePlugin = new webpack.ProvidePlugin({
 const optimizeAssetsPlugin = new OptimizeCssAssetsPlugin({
   assetNameRegExp: /\.css$/g,
   cssProcessor: require('cssnano'),
-  cssProcessorOptions: { discardComments: {removeAll: true } },
+  cssProcessorOptions: {
+    discardComments: {
+      removeAll: true,
+    },
+  },
   canPrint: true,
 });
 
@@ -55,11 +62,22 @@ const optimizeAssetsPlugin = new OptimizeCssAssetsPlugin({
 // Reference: https://webpack.js.org/plugins/source-map-dev-tool-plugin/#components/sidebar/sidebar.jsx
 const sourceMapDevToolPlugin = new webpack.SourceMapDevToolPlugin({
   filename: '[name].js.map',
-  exclude: ['vendor.js', 'codemirror.js', 'popper.js'],
+  exclude: /(vendor|codemirror|slickgrid|pgadmin\.js|style\.js|popper)/,
   columns: false,
 });
 
+// Supress errors while compiling as the getChunkURL method will be available
+// on runtime. window.getChunkURL is defined in base.html
+const webpackRequireFrom = new WebpackRequireFromPlugin({
+  methodName: 'getChunkURL',
+  supressErrors: true,
+});
 
+// can be enabled using bundle:analyze
+const bundleAnalyzer = new BundleAnalyzerPlugin({
+  analyzerMode: analyzerMode,
+  reportFilename: 'analyze_report.html',
+});
 
 function cssToBeSkiped(curr_path) {
   /** Skip all templates **/
@@ -119,6 +137,7 @@ module.exports = {
   entry: {
     'app.bundle': sourceDir + '/bundle/app.js',
     codemirror: sourceDir + '/bundle/codemirror.js',
+    slickgrid: sourceDir + '/bundle/slickgrid.js',
     sqleditor: './pgadmin/tools/sqleditor/static/js/sqleditor.js',
     debugger_direct: './pgadmin/tools/debugger/static/js/direct.js',
     file_utils: './pgadmin/misc/file_manager/static/js/utility.js',
@@ -131,6 +150,7 @@ module.exports = {
     libraryTarget: 'amd',
     path: __dirname + '/pgadmin/static/js/generated',
     filename: '[name].js',
+    chunkFilename: '[name].chunk.js',
     libraryExport: 'default',
   },
   // Templates files which contains python code needs to load dynamically
@@ -153,7 +173,7 @@ module.exports = {
       use: {
         loader: 'babel-loader',
         options: {
-          presets: [['@babel/preset-env', {'modules': 'commonjs'}]],
+          presets: [['@babel/preset-env', {'modules': 'commonjs', 'useBuiltIns': 'usage', 'corejs': 3}]],
         },
       },
     }, {
@@ -161,7 +181,7 @@ module.exports = {
       use: {
         loader: 'babel-loader',
         options: {
-          presets: [['@babel/preset-env', {'modules': 'commonjs'}]],
+          presets: [['@babel/preset-env', {'modules': 'commonjs', 'useBuiltIns': 'usage', 'corejs': 3}]],
         },
       },
     }, {
@@ -354,18 +374,58 @@ module.exports = {
         parallel: true,
         cache: true,
         uglifyOptions: {
-          compress: false,
+          compress: true,
+          extractComments: true,
+          output: {
+            comments: false,
+          },
         },
       }),
     ],
     splitChunks: {
       cacheGroups: {
-        vendors: {
-          name: 'vendors',
-          filename: 'vendor.js',
+        slickgrid: {
+          name: 'slickgrid',
+          filename: 'slickgrid.js',
           chunks: 'all',
           reuseExistingChunk: true,
-          priority: 1,
+          priority: 9,
+          minChunks: 2,
+          enforce: true,
+          test(module) {
+            return webpackShimConfig.matchModules(module, 'slickgrid');
+          },
+        },
+        codemirror: {
+          name: 'codemirror',
+          filename: 'codemirror.js',
+          chunks: 'all',
+          reuseExistingChunk: true,
+          priority: 8,
+          minChunks: 2,
+          enforce: true,
+          test(module) {
+            return webpackShimConfig.matchModules(module, 'codemirror');
+          },
+        },
+        vendor_main: {
+          name: 'vendor_main',
+          filename: 'vendor.main.js',
+          chunks: 'all',
+          reuseExistingChunk: true,
+          priority: 7,
+          minChunks: 2,
+          enforce: true,
+          test(module) {
+            return webpackShimConfig.matchModules(module, ['wcdocker', 'backbone', 'jquery', 'bootstrap', 'popper']);
+          },
+        },
+        vendor_others: {
+          name: 'vendor_others',
+          filename: 'vendor.others.js',
+          chunks: 'all',
+          reuseExistingChunk: true,
+          priority: 6,
           minChunks: 2,
           enforce: true,
           test(module) {
@@ -376,13 +436,24 @@ module.exports = {
           name: 'pgadmin_commons',
           filename: 'pgadmin_commons.js',
           chunks: 'all',
-          priority: 2,
+          priority: 5,
           minChunks: 2,
           enforce: true,
           test(module) {
             return webpackShimConfig.isPgAdminLib(module);
           },
         },
+        browser_nodes: {
+          name: 'browser_nodes',
+          filename: 'browser_nodes.js',
+          chunks: 'all',
+          priority: 4,
+          minChunks: 2,
+          enforce: true,
+          test(module) {
+            return webpackShimConfig.isBrowserNode(module);
+          },
+        },
       },
     },
   },
@@ -393,9 +464,12 @@ module.exports = {
     providePlugin,
     optimizeAssetsPlugin,
     sourceMapDevToolPlugin,
+    webpackRequireFrom,
+    bundleAnalyzer,
   ]: [
     extractStyle,
     providePlugin,
     sourceMapDevToolPlugin,
+    webpackRequireFrom,
   ],
 };
diff --git a/web/webpack.shim.js b/web/webpack.shim.js
index ca5f72c9..b4d3b859 100644
--- a/web/webpack.shim.js
+++ b/web/webpack.shim.js
@@ -68,9 +68,6 @@ var webpackShimConfig = {
     'backgrid.filter': {
       'deps': ['backgrid'],
     },
-    'backgrid.sizeable.columns': {
-      'deps': ['backgrid'],
-    },
     'jquery.event.drag': {
       'deps': ['jquery'], 'exports': 'jQuery.fn.drag',
     },
@@ -138,13 +135,12 @@ var webpackShimConfig = {
     'translations': path.join(__dirname, './pgadmin/tools/templates/js/translations'),
     'sources/gettext': path.join(__dirname, './pgadmin/static/js/gettext'),
     'sources/utils': path.join(__dirname, './pgadmin/static/js/utils'),
-    'babel-polyfill': path.join(__dirname, './node_modules/@babel/polyfill/dist/polyfill'),
     'tools': path.join(__dirname, './pgadmin/tools/'),
     'pgbrowser': path.join(__dirname, './pgadmin/browser/static/js/'),
 
     // Vendor JS
     'jquery': path.join(__dirname, './node_modules/jquery/dist/jquery'),
-    'wcdocker': path.join(__dirname, './node_modules/webcabin-docker/Build/wcDocker'),
+    'wcdocker': path.join(__dirname, './node_modules/webcabin-docker/Build/wcDocker.min'),
     'alertify': path.join(__dirname, './node_modules/alertifyjs/build/alertify'),
     'moment': path.join(__dirname, './node_modules/moment/moment'),
     'jquery.event.drag': path.join(__dirname, './node_modules/slickgrid/lib/jquery.event.drag-2.3.0'),
@@ -156,7 +152,7 @@ var webpackShimConfig = {
     'dropzone': path.join(__dirname, './node_modules/dropzone/dist/dropzone'),
     'bignumber': path.join(__dirname, './node_modules/bignumber.js/bignumber'),
     'json-bignumber': path.join(__dirname, './node_modules/json-bignumber/dist/JSONBigNumber.min'),
-    'snap.svg': path.join(__dirname, './node_modules/snapsvg/dist/snap.svg'),
+    'snap.svg': path.join(__dirname, './node_modules/snapsvg/dist/snap.svg-min'),
     'spectrum': path.join(__dirname, './node_modules/spectrum-colorpicker/spectrum'),
     'mousetrap': path.join(__dirname, './node_modules/mousetrap'),
 
@@ -170,12 +166,11 @@ var webpackShimConfig = {
     'backbone': path.join(__dirname, './node_modules/backbone/backbone'),
     'backbone.undo': path.join(__dirname, './node_modules/backbone-undo/Backbone.Undo'),
     'backform': path.join(__dirname, './pgadmin/static/vendor/backform/backform'),
-    'backgrid': path.join(__dirname, './node_modules/backgrid/lib/backgrid'),
+    'backgrid': path.join(__dirname, './pgadmin/static/vendor/backgrid/backgrid'),
     'bootstrap.datetimepicker': path.join(__dirname, './node_modules/tempusdominus-bootstrap-4/build/js/tempusdominus-bootstrap-4.min'),
     'bootstrap.toggle': path.join(__dirname, './node_modules/bootstrap4-toggle/js/bootstrap4-toggle'),
     'select2': path.join(__dirname, './node_modules/select2/dist/js/select2.full'),
     'backgrid.filter': path.join(__dirname, './node_modules/backgrid-filter/backgrid-filter'),
-    'backgrid.sizeable.columns': path.join(__dirname, './node_modules/backgrid-sizeable-columns/backgrid-sizeable-columns'),
     'backgrid.select.all': path.join(__dirname, './node_modules/backgrid-select-all/backgrid-select-all'),
     'pgadmin.alertifyjs': path.join(__dirname, './pgadmin/static/js/alertify.pgadmin.defaults'),
     'pgadmin.backform': path.join(__dirname, './pgadmin/static/js/backform.pgadmin'),
@@ -311,13 +306,36 @@ var webpackShimConfig = {
   isExternal: function(module) {
     var context = module.context;
     if (typeof context !== 'string') { return false; }
-    return context.indexOf('node_modules') !== -1;
+    return (context.indexOf('node_modules') !== -1 || context.indexOf('vendor') !== -1);
   },
   // Checks whether module is in pgLibs or not. Returns true if exists
   isPgAdminLib: function (module) {
     if (module.rawRequest === undefined) { return false; }
     return this.pgLibs.indexOf(module.rawRequest) !== -1;
   },
+  isBrowserNode: function(module) {
+    if (module.rawRequest === undefined) { return false; }
+    if(module.rawRequest.startsWith('pgadmin.node')) {
+      return true;
+    }
+    return false;
+  },
+  matchModules: function(module, match_modules) {
+    if (module.rawRequest === undefined) { return false; }
+    if(typeof match_modules === 'string') {
+      if(module.rawRequest.indexOf(match_modules) >= 0) {
+        return true;
+      }
+    } else {
+      for(let i=0; i<match_modules.length; i++) {
+        if(module.rawRequest.indexOf(match_modules[i]) >= 0) {
+          return true;
+        }
+      }
+    }
+    return false;
+  },
+
   /* These will be skipped when webpack picks css/scss files recursively to bundle */
   css_bundle_skip: [
     './pgadmin/static',
diff --git a/web/webpack.test.config.js b/web/webpack.test.config.js
index f19d666c..3d153620 100644
--- a/web/webpack.test.config.js
+++ b/web/webpack.test.config.js
@@ -21,7 +21,6 @@ module.exports = {
     new webpack.ProvidePlugin({
       jQuery: 'jquery',
       _: 'underscore',
-      'underscore.string': 'underscore.string',
       'window.jQuery': 'jquery',
       'moment': 'moment',
       'window.moment':'moment',
@@ -36,7 +35,7 @@ module.exports = {
         use: {
           loader: 'babel-loader',
           options: {
-            presets: [['@babel/preset-env', {'modules': 'commonjs'}]],
+            presets: [['@babel/preset-env', {'modules': 'commonjs', 'useBuiltIns': 'usage', 'corejs': 3}]],
             sourceMap: 'inline',
           },
         },
@@ -82,7 +81,7 @@ module.exports = {
       'bootstrap.toggle': path.join(__dirname, './node_modules/bootstrap4-toggle/js/bootstrap4-toggle'),
       'backbone': path.join(__dirname, './node_modules/backbone/backbone'),
       'backform': path.join(__dirname, './node_modules/backform/src/backform'),
-      'backgrid': path.join(__dirname, './node_modules/backgrid/lib/backgrid'),
+      'backgrid': path.join(__dirname, './pgadmin/static/vendor/backgrid/backgrid'),
       'backgrid.filter': path.join(__dirname, './node_modules/backgrid-filter/backgrid-filter'),
       'sources': sourcesDir + '/js',
       'translations': regressionDir + '/javascript/fake_translations',
